//FilelightGroup, FilelightSite

GUI.Plugin.FilelightSite = new function()
{
  var _gcanvas = document.getElementById('canvas-area');
  var _gui = null;
  var _self = this;
  
  this.img = null;
  this.select_site = null;
  this.check_group = null;
  this.site_list = null;
  this.site = null;
  this.in_width = null;
  this.in_height = null;
  this.in_type = null;
  
  this.attach = function(gui)
  {
    _gcanvas.style.top = 0;
    _gcanvas.style.bottom = 0;
    _gui = gui;
    
    var content = ""
      + "<div id='filelight-options' style='width:100%;padding:5px'>"
      + "<img style='cursor:pointer' href='#' onclick='return GUI.Plugin.FilelightSite.moveRel(-1)' alt='Previous' src='"+ROOTPATH+"/static/left.gif'>" 
      + "<img style='cursor:pointer' href='#' onclick='return GUI.Plugin.FilelightSite.moveRel(1)' alt='Previous' src='"+ROOTPATH+"/static/right.gif'>" 
      + "Site: "
      + "<select id='filelight-site-select' onchange='return GUI.Plugin.FilelightSite.updateSite(this.value)'>"
      + "<option value='null'></option>"
      + "</select>"
      + "Show group: <input type='checkbox' id='filelight-site-group' onclick='return GUI.Plugin.FilelightSite.updateGroup(this.value)'>"
      + "Size: <input id='filelight-width' size=4>x<input id='filelight-height' size=4> <a href='#' onclick='return GUI.Plugin.FilelightSite.updateSize()'>submit</a>"
      + "</div>"
      + "<div id='filelight-image-area' style='background-image:url(\""+ROOTPATH+"/static/progress.gif\");background-repeat:no-repeat;background-position:center'>"
      + "<img id='filelight-image' width=800>"
      + "</div>";
      
    
    if (_gcanvas.innerHTML != content) _gcanvas.innerHTML = content;
    
    if (_gcanvas.style.display != '') _gcanvas.style.display = '';
    
    this.img = document.getElementById("filelight-image");
    this.select_site = document.getElementById("filelight-site-select");
    this.check_group = document.getElementById("filelight-site-group");
    
  }
  
  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }
  
  this.moveRel = function(n)
  {
    for (i in _self.site_list) {
      if (_self.site_list[i]==_self.site) {
        var index = (i+n) % _self.site_list.length;
        return this.updateSite(_self.site_list[index]);
      }
    }
  }
  
  this.updateSize = function() {
    var width = document.getElementById('filelight-width').value;
    var height = document.getElementById('filelight-height').value;
    _gui.makeCall(_url()+"/opt?width="+encodeURIComponent(width)+";height="+encodeURIComponent(height));
  }
  
  this.updateSite = function(site)
  {
    if (site != 'null') {
      _gui.makeCall(_url()+"/opt?site="+encodeURIComponent(site));
    }
  }
  
  this.updateGroup = function(group)
  {
    if (group) {
      _gui.makeCall(_url()+"/opt?group=1");
    } else {
      _gui.makeCall(_url()+"/opt?group=0");
    }
  }
  
  this.update = function(data)
  {
    
    var width = data['width'];
    var height = data['height'];
    var type = data['type'];
    var site = data['site'];
    var sites = data['sites'];
    var group = data['group'];
    
    this.site_list = sites;
    this.site = site;
    
    document.getElementById('filelight-height').value = height;
    document.getElementById('filelight-width').value = width;
    
    var select_html = "<option value='null'></option>";
    for (i in sites) {
      if (sites[i]==site) {
        select_html += "<option value='"+sites[i]+"' selected>"+sites[i]+"</option>";
      } else {
        select_html += "<option value='"+sites[i]+"'>"+sites[i]+"</option>";
      }
    }
    this.select_site.innerHTML = select_html;
    
    var optstr = "?width="+width+";height="+height+";type="+type;
    if (group == "1") {
      optstr += ";group=1";
    }
    
    if (site != "null") {
      this.img.width = parseInt(width);
      this.img.style.visibility='hidden';
      this.img.onload = function() {document.getElementById("filelight-image").style.visibility='visible';};
      this.img.src = ROOTPATH + '/plotfairy/filelight/site/'+encodeURIComponent(site)+optstr;
    }
  }
}






GUI.Plugin.FilelightGroup = new function()
{
  var _gcanvas = document.getElementById('canvas-area');
  var _gui = null;
  var _self = this;
  
  this.img = null;
  this.select_group = null;
  this.group_list = null;
  this.group = null;
  this.in_width = null;
  this.in_height = null;
  this.in_type = null;
  
  this.attach = function(gui)
  {
    _gcanvas.style.top = 0;
    _gcanvas.style.bottom = 0;
    _gui = gui;
    
    var content = ""
      + "<div id='filelight-options' style='width:100%'>"
      + "<img style='cursor:pointer' href='#' onclick='return GUI.Plugin.FilelightGroup.moveRel(-1)' alt='Previous' src='"+ROOTPATH+"/static/left.gif'>" 
      + "<img style='cursor:pointer' href='#' onclick='return GUI.Plugin.FilelightGroup.moveRel(1)' alt='Previous' src='"+ROOTPATH+"/static/right.gif'>" 
      + "Group: "
      + "<select id='filelight-group-select' onchange='return GUI.Plugin.FilelightGroup.updateGroup(this.value)'>"
      + "<option value='null'></option>"
      + "</select>"
      + "Size: <input id='filelight-width' size=4>x<input id='filelight-height' size=4> <a href='#' onclick='return GUI.Plugin.FilelightGroup.updateSize()'>submit</a>"
      + "</div>"
      + "<div id='filelight-image-area' style='background-image:url(\""+ROOTPATH+"/static/progress.gif\");background-repeat:no-repeat;background-position:center'>"
      + "<img id='filelight-image' width=800>"
      + "</div>";
      
    
    if (_gcanvas.innerHTML != content) _gcanvas.innerHTML = content;
    
    if (_gcanvas.style.display != '') _gcanvas.style.display = '';
    
    this.img = document.getElementById("filelight-image");
    this.select_group = document.getElementById("filelight-group-select");
    
  }
  
  this.detach = function()
  {
    while (_gcanvas.firstChild)
      _gcanvas.removeChild(_gcanvas.firstChild);
  }
  
  this.moveRel = function(n)
  {
    for (i in _self.group_list) {
      if (_self.group_list[i]==_self.group) {
        var index = (i+n) % _self.group_list.length;
        return this.updateGroup(_self.group_list[index]);
      }
    }
  }
  
  this.updateSize = function() {
    var width = document.getElementById('filelight-width').value;
    var height = document.getElementById('filelight-height').value;
    _gui.makeCall(_url()+"/opt?width="+encodeURIComponent(width)+";height="+encodeURIComponent(height));
  }
  
  this.updateGroup = function(group)
  {
    if (group != 'null') {
      _gui.makeCall(_url()+"/opt?group="+encodeURIComponent(group));
    }
  }
  
  
  this.update = function(data)
  {
    
    var width = data['width'];
    var height = data['height'];
    var type = data['type'];
    var group = data['group'];
    var groups = data['groups'];
    
    this.group = group;
    this.group_list = groups;
    
    document.getElementById('filelight-height').value = height;
    document.getElementById('filelight-width').value = width;
    
    var select_html = "<option value='null'></option>";
    for (i in groups) {
      if (groups[i]==group) {
        select_html += "<option value='"+groups[i]+"' selected>"+groups[i]+"</option>";
      } else {
        select_html += "<option value='"+groups[i]+"'>"+groups[i]+"</option>";
      }
    }
    this.select_group.innerHTML = select_html;
    
    var optstr = "?width="+width+";height="+height+";type="+type;
    
    if (group != "null") {
      this.img.width = parseInt(width);
      this.img.style.visibility='hidden';
      this.img.onload = function() {document.getElementById("filelight-image").style.visibility='visible';};
      this.img.src = ROOTPATH + '/plotfairy/filelight/group/'+encodeURIComponent(group)+optstr;
    }
  }
}